#import <Foundation/Foundation.h>

// BWLog.h

// BWLogging - spiffy multi-module configurable logging facility.
// now with the great taste of fish.
typedef int BWLogLevel;

enum {
    // values are arbitrary.  a <= operation is done to determine whether
    // to log.  Feel free to add your own values if you feel appropriate.
    BWFatal	= 100,  // terminates the program with an abort()
    BWError	= 200,
    BWarning	= 300,
    BWNotice	= 400,	// the default
    BWDebug	= 500,
    BWTrace	= 600,
    BWVerbose	= 700
};
#define BWDefaultLogLevel	BWNotice
// #define BWDefaultLogLevel	BWTrace

@interface BWLogModule : NSObject
{
    NSString	*moduleName;
    BOOL	 loggingEnabled;
    const char	*cvsId;
@public
    BWLogLevel	 logLevel;
    
} BWLogModule;

+ (BWLogModule *) registerModule: (NSString *) name  
	withCVSId: (const char *) cvsId;

+ (NSArray *) getRegisteredModules;
+ (BWLogModule *) getModuleByName: (NSString *) name;
+ (BWLogModule *) registerModule: (NSString *) name;

- (void) enableLogging;
- (void) disableLogging;
- (BOOL) isLogging;

- (void) setLogLevel: (BWLogLevel) level;
- (BWLogLevel) logLevel;

- (NSString *) name;
- (const char *) CVSId;

@end // BWLogModule

void BWLog (BWLogModule *module, BWLogLevel loglevel, NSString *format, ...);

